// score: 70

#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define mp make_pair
#define ff first
#define ss second
#define eb emplace_back

typedef long long ll;

const int INF = 1e9;

// l inclusive, r exclusive
int get_pts(const vector<int> &cum, int l, int r) {
	if (l == r) { // empty
		return 0;
	} else if (l == 0) {
		return cum[r-1];
	} else {
		return cum[r-1] - cum[l-1];
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	
	int n, k; cin >> n >> k;
	vector<int> pts(n, 0);
	for (int i=0; i<n; i++) {
		cin >> pts[i];
		if (i > 0) {
			pts[i] += pts[i-1];
		}
	}
	
	int res = INF;
	if (k == 1) {
		for (int i=0; i<=n; i++) {
			int a = get_pts(pts, 0, i);
			int b = get_pts(pts, i, n);
			res = min(res, abs(a - b));
		}
	} else {
		for (int i=0; i<=n; i++) {
			for (int j=i; j<=n; j++) {
				int a = get_pts(pts, 0, i);
				int b = get_pts(pts, i, j);
				int c = get_pts(pts, j, n);
				int maxi = max(max(a, b), c);
				int mini = min(min(a, b), c);
				res = min(res, maxi - mini);
			}
		}
	}
	cout << res << endl;
}
