#include <bits/stdc++.h>  // score: 50
using namespace std;

vector<string> words;
string s;
bool match(size_t i, size_t j) {
  return strncmp(s.data()+i, words[j].data(), words[j].size()) == 0;
}

void backtrack(int i, size_t word_cnt, vector<int>& ans, size_t& ans_ptr) {
  if (word_cnt==0 && i==0) { assert(ans_ptr==0 ? ans.empty() : true); ++ans_ptr; return; }
  if (word_cnt==0 || i==0) { return; }

  for (size_t j=0; j<words.size(); ++j) {
    if (ans_ptr > 2) return;
    if (i >= words[j].size() && match(i - words[j].size(), j)) {
      size_t ans_ptr_old = ans_ptr;
      backtrack(i - words[j].size(), word_cnt-1, ans, ans_ptr);
      if (ans_ptr_old==0 && ans_ptr>0)
        ans.push_back(j);
    }
  }
}

int main() {
  int n, m, k; cin >> n >> m >> k;
  cin >> s;
  copy_n(istream_iterator<string>(cin), k, back_inserter(words));
  vector<int> ans;
  size_t num_ans=0;
  backtrack(s.size(), n, ans, num_ans);
  if (num_ans==0) {
    cout << "not decodable\n";
  } else if (num_ans==1) {
    for (auto x : ans) cout << char(x+'A');
    cout << '\n';
  } else {
    cout << "not uniquely decodable\n";
  }
}
