# score: 100
impossible = 0xFF;
ambiguous  = 0xFE;
unique_eof = 0xFD;

n, m, k = map(int, input().split())
s=input()
words = [input() for _ in range(k)]
ans=[]
match = [
    [j for j, w in enumerate(words) if i>=len(w) and s[i-len(w):i] == w]
    for i in range(len(s)+1)
]

dp=[[impossible]*(n+1) for _ in range(m+1)]
dp[0][0] = unique_eof
for i in range(1, m+1):
    for j in range(1, n+1):
        a = impossible
        for k in match[i]:
            x = dp[i - len(words[k])][j-1]
            if x == impossible:
                continue
            elif a != impossible:
                a = ambiguous
                break
            elif x < ambiguous:
                a = k
            else:
                a = x
                if a == ambiguous:
                    break
        dp[i][j] = a

x = dp[m][n]
if x == impossible:
    print("not decodable")
elif x < ambiguous:
    t=[]
    while x != unique_eof:
        t.append(chr(x+ord('A')))
        n -= 1
        m -= len(words[x])
        x = dp[m][n]
    print(''.join(reversed(t)))
else:
  print("not uniquely decodable")
