// score: 60
// only k=2


#include <bits/stdc++.h>
using namespace std;

using ll = int64_t;

template<typename T>
void xmin(T&a, T const&b){
    a = min(a, b);
}

template<typename T>
void xmax(T&a, T const&b){
    a = max(a, b);
}


constexpr ll inf = 1e18;

signed main(){
    cin.tie(0); ios_base::sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    assert(k == 2);
    ++k;
    vector<int> v(n);
    for(auto &e:v) cin >> e;
    vector<ll> pre(n+1, 0);
    for(int i=0;i<n;++i){
        pre[i+1] = pre[i] + v[i];
    }
    pre.emplace_back(inf);
    auto next_non_smaller = [&](ll x){
        return lower_bound(pre.begin(), pre.end(), x) - pre.begin();
    };
    ll ans = inf;
    auto cand = [&](ll x, ll y, ll z){
        xmin(ans, max({x, y, z}) - min({x, y, z}));
    };
    const int A = next_non_smaller(pre[n]/3);
    const int B = next_non_smaller(2*pre[n]/3);
    const int BLOCK = *max_element(v.begin(), v.end());

    for(int i=max(0, A-BLOCK);i<=min(A+BLOCK, n);++i){
        for(int j=max(i, B-BLOCK); j<=min(B+BLOCK, n);++j){
            cand(pre[i]-pre[0], pre[j]-pre[i], pre[n]-pre[j]);
        }
    }
    cout << ans << "\n";
}
