// score: 100

#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define mp make_pair
#define ff first
#define ss second
#define eb emplace_back

typedef long long ll;

const int INF = 1e9;

// l inclusive, r exclusive
int get_pts(const vector<int> &cum, int l, int r) {
	if (l == r) { // empty
		return 0;
	} else if (l == 0) {
		return cum[r-1];
	} else {
		return cum[r-1] - cum[l-1];
	}
}

int get_largest_difference(int a, int b, int c) {
	int maxi = max(max(a, b), c);
	int mini = min(min(a, b), c);
	return maxi - mini;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	
	int n, k; cin >> n >> k;
	vector<int> pts(n, 0);
	for (int i=0; i<n; i++) {
		cin >> pts[i];
		if (i > 0) {
			pts[i] += pts[i-1];
		}
	}
	
	int res = INF;
	if (k == 1) {
		for (int i=0; i<=n; i++) {
			int a = get_pts(pts, 0, i);
			int b = get_pts(pts, i, n);
			res = min(res, abs(a - b));
		}
	} else {
		for (int i=0; i<=n; i++) {
			int l = i, r = n;
			while (l != r) {
				int mid = (l+r)/2;
				int a = get_pts(pts, i, mid);
				int b = get_pts(pts, mid, n);
				if (a - b >= 0) {
					r = mid;
				} else {
					l = mid + 1;
				}
			}
			int a = get_pts(pts, 0, i);
			int b = get_pts(pts, i, l);
			int c = get_pts(pts, l, n);
			res = min(res, get_largest_difference(a, b, c));
			
			if (l > i) {
				l--;
				a = get_pts(pts, 0, i);
				b = get_pts(pts, i, l);
				c = get_pts(pts, l, n);
				res = min(res, get_largest_difference(a, b, c));
			}
		}
	}
	cout << res << endl;
}
